package gus05.entity.gus.app.action.about2;


import java.util.Map;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Execute;
import gus05.framework.features.Provide;
import gus05.framework.resources.ActionBuilder;
import gus05.framework.resources.StringProvider;



public class AppActionAbout2 implements Entity, Provide, Execute {


    public String getName()				{return "gus.app.action.about2";}
    public String getCreationDate()		{return "2007.03.21";}

    
    public static final String PROPKEY_ABOUTINFO = "app.aboutinfo";
    public static final String PROPKEY_ABOUTICON = "app.abouticon";
    

    private ActionBuilder actionBuilder;
    private StringProvider lingString;
    private Map prop;
    
    private String ling(String key)
    {return lingString.getString(key);}
    
    
    private Action aboutAction;
    
    private JFrame mainFrame;
    private AboutDialog dialog;
    
    

    public AppActionAbout2() throws Exception
    {
        actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
        lingString = (StringProvider) Outside.resource(this,"lingString");
        aboutAction = actionBuilder.build("about",this);
        prop = (Map) Outside.resource(this,"app.prop.map");
        
        mainFrame = (JFrame) Outside.resource(this,"app.gui.frame");
        String appName = (String) Outside.resource(this,"app.title");
        String appVersion = (String) Outside.resource(this,"app.version");
        String appBuild = (String) Outside.resource(this,"app.creationdate");
        
        ImageIcon aboutIcon = (ImageIcon) Outside.resource(this,"icon#about");
        Icon iconGus05 = (Icon) Outside.resource(this,"icon#gus05");
        String info = aboutInfo();
        
        dialog = new AboutDialog(mainFrame,appName,appVersion,appBuild,info,iconGus05);
//        dialog.setIconImage(aboutIcon.getImage());
    }



    public Object provide() throws Exception
    {return aboutAction;}
    
    
    
    public void execute() throws Exception
    {
        String about = ling("TITLE_about");
        String close = ling("BUTTON_close");
        String info = aboutInfo();
        
        if(info!=null) dialog.infoLabel().setText(info);
        dialog.closeButton().setText(close);
        dialog.setTitle(about);
        dialog.setVisible(true);
    }
    
    
    
    private String aboutInfo()
    {
        if(!prop.containsKey(PROPKEY_ABOUTINFO)) return null;
        String aboutInfo = (String) prop.get(PROPKEY_ABOUTINFO);
        return ling(aboutInfo);
    }
}

