package gus05.entity.gus.data.transform.proptostring;


import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.util.Map;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Transform;



public class PropToString implements Entity, Transform {


    public String getName()				{return "gus.data.transform.proptostring";}
    public String getCreationDate()		{return "2008.11.20";}


    private File storeDir;

    public PropToString() throws Exception
    {
    	storeDir = (File) Outside.resource(this,"defaultdir");
    }



    public Object transform(Object obj) throws Exception
    {
    	Properties p = toProp(obj);
    	File f = new File(storeDir,"tmp");
    	save(f,p);
    	f.deleteOnExit();
        return text(f);
    }
    
    
    
    private void save(File f, Properties p) throws Exception
    {
    	FileOutputStream fos = new FileOutputStream(f);
        p.store(fos,"");
        fos.close();
    }
    
    
    private String text(File f) throws Exception
    {
    	FileReader fr = new FileReader(f);	
        char[] a= new char[(int)f.length()];
        fr.read(a,0,(int)f.length());
        fr.close();
        return new String(a);
    }

    

    private Properties toProp(Object obj) throws Exception
    {
    	if(obj instanceof Properties) return (Properties) obj;
    	if(obj instanceof Map)
    	{
    		Properties prop = new Properties();
    		prop.putAll((Map)obj);
    	}
    	throw new Exception("Invalid data type: "+obj.getClass().getName());
    }
}

