package gus05.entity.gus.file.dirscan.info.handler.digest1;


import java.io.File;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Transform;



public class HandlerDigest1 implements Entity, Give, Provide, Transform, Filter {


    public String getName()				{return "gus.file.dirscan.info.handler.digest1";}
    public String getCreationDate()		{return "2006.09.06";}


    
    private Service digest;
    private Hashtable md_file;
    private Hashtable file_md;
    
    
    private HashSet set(String MD)
    {
        if(!md_file.containsKey(MD)) md_file.put(MD,new HashSet());
        return (HashSet) md_file.get(MD);
    }
    
    
    
    private boolean isMultipleMD(String MD)
    {return set(MD).size()>1;}

    
    private boolean isMultipleMDFile(File file) throws Exception
    {
        if(!file_md.containsKey(file))
            throw new Exception("File not handled yet: "+file);
        String MD = (String) file_md.get(file);
        return isMultipleMD(MD);
    }
    
    

    public HandlerDigest1() throws Exception
    {
        digest = Outside.service(this,"gus.file.read.info.messagedigest");
        md_file = new Hashtable(200);
        file_md = new Hashtable(200);
    }



    public void give(Object obj) throws Exception
    {
        if(obj==null)purge();
        else handleFile((File)obj);
    }


    public Object provide() throws Exception
    {return md_file;}

    
    public Object transform(Object obj) throws Exception
    {
        File file = (File)obj;
        if(!file_md.containsKey(file))
            handleFile(file);
        return file_md.get(file);
    }
    
    
    public boolean filter(Object obj) throws Exception
    {
        if(obj instanceof String) return isMultipleMD((String)obj);
        if(obj instanceof File) return isMultipleMDFile((File)obj);
        throw new Exception("Invalid data type: "+obj.getClass().getName());
    }
    
    
    
    private void handleFile(File file) throws Exception
    {
        if(file.isDirectory())return;
        String MD = (String) digest.transform(file);
        
        if(file_md.containsKey(file))
        {
            String previousMD = (String)file_md.get(file);
            if(previousMD.equals(MD)) return;
            set(previousMD).remove(file);
        }
        set(MD).add(file);
        file_md.put(file,MD);
    }
    
    
    
    private void purge()
    {
        Iterator it = file_md.keySet().iterator();
        while(it.hasNext())
        {
            File f = (File) it.next();
            if(!f.exists())
            {
                String MD = (String) file_md.get(f);
                set(MD).remove(f);
                it.remove();
            }
        }
    }
    
    
}

