
package gus05.entity.gus.graphic.dnd;


import gus05.framework.features.Give;
import gus05.framework.features.Provide;

import java.awt.event.*;
import javax.swing.*;
import java.awt.datatransfer.*;




class TransferHandler0 extends TransferHandler implements MouseListener {
    
    private Give give;
    private Provide provide;
    private DataFlavor flavor;
    
    public TransferHandler0(Give give, Provide provide, JComponent source, DataFlavor flavor)
    {
        super();
        this.give = give;
        this.provide = provide;
        this.flavor = flavor;
        
        source.setTransferHandler(this);
        source.addMouseListener(this);
    }
    
    
    
    protected Transferable createTransferable(JComponent c)
    {
        try
        {
            Object data = provide.provide();
            return new ObjectTransferable(data,flavor);
        }
        catch (Exception e) {} 
        return null; 
    }
     
    
    
    public int getSourceActions(JComponent c)
    {return COPY;}
    
    
    public boolean importData(JComponent c, Transferable t)
    {
        try
        {
            if(give==null)return false;
            Object data = t.getTransferData(flavor);
            if(data instanceof Provide) data = ((Provide)data).provide();
            give.give(data);
            return true;
        }
        catch (Exception e) {} 
        return false;
    }
    
    
    public boolean canImport(JComponent c, DataFlavor[] flavors)
    {return give!=null;}
    
    
    
    
    public void mousePressed(MouseEvent e)
    {
        JComponent source = (JComponent)e.getSource();
        exportAsDrag(source,e,COPY);
    }
    
    public void mouseClicked(MouseEvent e){}
    public void mouseReleased(MouseEvent e){}
    public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
}
