package gus05.entity.gus.graphic.lookandfeel.inituimanager;


import java.awt.Color;
import java.awt.Font;
import java.util.Iterator;
import java.util.Map;

import javax.swing.Icon;
import javax.swing.ToolTipManager;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.plaf.BorderUIResource;
import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.FontUIResource;
import javax.swing.plaf.IconUIResource;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;



public class InitUIManager implements Entity {


    public String getName()				{return "gus.graphic.lookandfeel.inituimanager";}
    public String getCreationDate()		{return "2007.02.03";}



    private Service convert;
    private Map map;

    public InitUIManager() throws Exception
    {
        convert = Outside.service(this,"gus.app.find.convert2");
        map = (Map) Outside.resource(this,"configMap");
        
        Iterator it = map.keySet().iterator();
        while(it.hasNext())
        {
            String key = (String) it.next();
            String value = (String) map.get(key);
            
            if(!key.startsWith("#"))
            handleKey(key,value);
        }
    }
    
    
    
    private void handleKey(String key, String value)
    {
        try
        {
            if(key.equals("tooltip.delay"))
            {
                int delay = Integer.parseInt(value);
                ToolTipManager.sharedInstance().setInitialDelay(delay);
                return;
            }
            Object element = convert.transform(value);
            element = convertToUIResource(element);
            UIManager.put(key,element);
        }
        catch(Exception e)
        {Outside.err(this,"handleKey(String,String)",e);}
    }
    
    
    
    
    
    private Object convertToUIResource(Object element) throws Exception
    {
        if(element instanceof Border) return new BorderUIResource((Border)element);
        if(element instanceof Color) return new ColorUIResource((Color)element);
        if(element instanceof Font) return new FontUIResource((Font)element);
        if(element instanceof Icon) return new IconUIResource((Icon)element);
        
        throw new Exception("Unknown UIResource for data type: "+element.getClass().getName());
    }


}

