/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.graphic.persistence.persistence1;


import gus05.framework.core.Service;

import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;


/**
 * @author user
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
class Persistence_JTable implements TableModelListener {

    
    private JTable table;
    private String key;
    private Service pers;
        
    
    
    public Persistence_JTable(Service pers, String key, JTable table) throws Exception
    {
        this.table = table;
        this.key = key;
        this.pers = pers;
        
        for(int i=0;i<table.getRowCount();i++)
        for(int j=0;j<table.getColumnCount();j++)
        {
            String keyCell = key+"_"+i+"_"+j;
            String value = (String)pers.retrieve(keyCell);
            if(value!=null)table.setValueAt(value,i,j);
        }
        table.getModel().addTableModelListener(this);
    }



    
    public void tableChanged(TableModelEvent e)
    {
        int x = e.getFirstRow();
        int y = e.getColumn();
        update(x,y);
    }
    
    
    
    
    
    
    private void update(int x, int y)
    {
        try
        {
            String keyCell = key+"_"+x+"_"+y;
            String value = (String)table.getValueAt(x,y);
            pers.register(keyCell,value);
        }
        catch(Exception e){}
    }


    
    
}
