/*
 * Created on 7 juin 2006
 *
 */
package gus05.entity.gus.icondisplay.file5;

import java.io.File;

import javax.swing.Icon;
import javax.swing.filechooser.FileSystemView;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Transform;
import gus05.framework.resources.IconProvider;


public class FileIcon5 implements Entity, Transform {

    public String getName()				{return "gus.icondisplay.file5";}
    public String getCreationDate()		{return "2007.01.24";}

    
    public static final String TYPE_SYSTEM = "system_";
    public static final String TYPE_DIR = "dir_";
    
    
    
    private IconProvider provider;

    public FileIcon5() throws Exception
    {provider = (IconProvider)Outside.resource(this,"app.gui.icons"); }
    
    
    public Object transform(Object arg0) throws Exception
    {
        File file = (File)arg0;
        
        String type = getFileType(file);
        if(type.equals("")) return systemIcon(file);
        
        Icon icon = provider.getIcon("FILE_"+type);
        if(icon==null) return systemIcon(file);
        
        return icon;
    }
    
    
    
 
    
    
    private String getFileType(File file)
    {
    	if(file.isFile())return getFileExtension(file);
        if(isDriver(file))return TYPE_SYSTEM;
    	if(isFileSystem(file))return TYPE_DIR;
        return TYPE_SYSTEM;
    }
    
  
    
    //les icones  l'intrieur du poste de travail
    private boolean isDriver(File file)  
    {return FileSystemView.getFileSystemView().isDrive(file);} 
    
    // TOUT sauf les fichiers
    private boolean isFileSystem(File file)
    {return FileSystemView.getFileSystemView().isFileSystem(file);}
    
    
    
    
    
    
    private String getFileExtension(File file)
    {
        String[] n = file.getName().split("\\.");
        if(n.length>1) return n[n.length-1].toLowerCase();
        return "";
    }
    
    
    private Icon systemIcon(File file)
    {
        if(!file.exists()) return null;
        return FileSystemView.getFileSystemView().getSystemIcon(file);
    }
    
}
