package gus05.entity.gus.security.asymkeys.privatekey.comparewithfile;


import java.io.File;
import java.io.FileInputStream;
import java.util.Map;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.resources.FileProvider;



public class CompareWithFile implements Entity, Filter {


    public String getName()				{return "gus.security.asymkeys.privatekey.comparewithfile";}
    public String getCreationDate()		{return "2008.11.21";}


    private Service filterMapEquals;
    private FileProvider fileChooser;
    
    
    public CompareWithFile() throws Exception
    {
    	filterMapEquals = Outside.service(this,"gus.filter.collection.map.equals");
    	fileChooser = (FileProvider) Outside.resource(this,"gus.file.action.choose.file");
    }



    public boolean filter(Object obj) throws Exception
    {
    	Map map = (Map) obj;
    	String owner = (String) map.get(SECURITY.PRIVATEKEY_OWNER);
    	
    	File file = fileChooser.getFile("open");
    	if(file==null) return false;
    	
    	String fileName = owner+"."+SECURITY.PRIVATEKEY_FILEEXTENSION;
    	if(!file.getName().equals(fileName)) return false;
    	
    	Properties prop0 = prop(file);
    	return filterMapEquals.filter(new Map[]{map,prop0});
    }
    
    
    
    private Properties prop(File file) throws Exception
	{
		Properties prop = new Properties();
		FileInputStream fis = new FileInputStream(file);
		prop.load(fis);
		fis.close();
		return prop;
	}


}

