package gus05.entity.gus.security.asymkeys.privatekey.proppanel1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.border.Border;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.util.Map;



public class PrivateKeyPropPanel1 implements Entity, Give, Graphic {


    public String getName()				{return "gus.security.asymkeys.privatekey.proppanel1";}
    public String getCreationDate()		{return "2008.07.01";}


    public static final Color BACKGROUND = new JLabel().getBackground();
    public static final Border EMPTY_BORDER = BorderFactory.createEmptyBorder(5,5,5,5);
    public static final String KEY_ERROR = "error";
    
    
    
    private Service form1;
    private Service form2;
    private Service form3;
    
    private JTextArea area_X1;
    private JTextArea area_P1;
    private JTextArea area_Q1;
    private JTextArea area_G1;
    
    private JTextArea area_Y0;
    private JTextArea area_P0;
    private JTextArea area_Q0;
    private JTextArea area_G0;
    
    private JTextArea area_owner;
    private JTextArea area_sign;
    private JTextArea area_valid;
    
    private JPanel panel;

    private Map prop;
    



    public PrivateKeyPropPanel1() throws Exception
    {
    	form1 = Outside.service(this,"gus.graphic.panel.form1-1");
    	form2 = Outside.service(this,"gus.graphic.panel.form1-2");
    	form3 = Outside.service(this,"gus.graphic.panel.form1-3");
    	

    	area_X1 = area();
    	area_P1 = area();
    	area_Q1 = area();
    	area_G1 = area();
    	
    	area_Y0 = area();
    	area_P0 = area();
    	area_Q0 = area();
    	area_G0 = area();
    	
    	area_owner = area();
    	area_sign = area();
    	area_valid = area();
    	
    	form1.register(SECURITY.PRIVATEKEY_X1,area_X1);
    	form1.register(SECURITY.PRIVATEKEY_P1,area_P1);
    	form1.register(SECURITY.PRIVATEKEY_Q1,area_Q1);
    	form1.register(SECURITY.PRIVATEKEY_G1,area_G1);
    	
    	form2.register(SECURITY.PRIVATEKEY_Y0,area_Y0);
    	form2.register(SECURITY.PRIVATEKEY_P0,area_P0);
    	form2.register(SECURITY.PRIVATEKEY_Q0,area_Q0);
    	form2.register(SECURITY.PRIVATEKEY_G0,area_G0);
    	
    	form3.register(SECURITY.PRIVATEKEY_OWNER,area_owner);
    	form3.register(SECURITY.PRIVATEKEY_SIGN,area_sign);
    	form3.register("validity",area_valid);
    	
    	
    	JPanel p1 = (JPanel) form1.gui();
    	p1.setBorder(BorderFactory.createTitledBorder(EMPTY_BORDER,"specifications - 1"));
    	
    	JPanel p2 = (JPanel) form2.gui();
    	p2.setBorder(BorderFactory.createTitledBorder(EMPTY_BORDER,"specifications - 0"));
    	
    	JPanel p3 = (JPanel) form3.gui();
    	p3.setBorder(BorderFactory.createTitledBorder(EMPTY_BORDER,"private key owner"));
    	
    	
    	JPanel p = new JPanel(new FlowLayout(FlowLayout.LEFT));
        p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
        p.add(p3);
    	p.add(p2);
    	p.add(p1);
    	
    	panel = new JPanel(new BorderLayout());
    	panel.add(p,BorderLayout.NORTH);
    }



    public void give(Object obj) throws Exception
    {
    	prop = (Map) obj;
    	if(prop==null) throw new Exception("null properties is not accepted");
    	
    	put(area_X1,prop,SECURITY.PRIVATEKEY_X1);
        put(area_P1,prop,SECURITY.PRIVATEKEY_P1);
        put(area_Q1,prop,SECURITY.PRIVATEKEY_Q1);
        put(area_G1,prop,SECURITY.PRIVATEKEY_G1);
        
        put(area_Y0,prop,SECURITY.PRIVATEKEY_Y0);
        put(area_P0,prop,SECURITY.PRIVATEKEY_P0);
        put(area_Q0,prop,SECURITY.PRIVATEKEY_Q0);
        put(area_G0,prop,SECURITY.PRIVATEKEY_G0);
        
        put(area_owner,prop,SECURITY.PRIVATEKEY_OWNER);
        put(area_sign,prop,SECURITY.PRIVATEKEY_SIGN);
        
        if(!prop.containsKey(KEY_ERROR))
        {
        	area_valid.setForeground(Color.GREEN);
        	area_valid.setText("GOOD");
        	area_valid.setToolTipText("GOOD");
        }
        else
        {
        	String errorMessage = (String) prop.get(KEY_ERROR);
        	area_valid.setForeground(Color.RED);
        	area_valid.setText("WRONG: "+errorMessage);
        	area_valid.setToolTipText("WRONG: "+errorMessage);
        }
    }



    public JComponent gui()
    {return panel;}


    
    private void put(JTextArea label, Map prop, String key) throws Exception
    {
    	if(!prop.containsKey(key))
    		throw new Exception("Property not found: "+key);
    	
    	String value = (String) prop.get(key);
    	label.setText(value);
    	label.setToolTipText(value);
    }
    
    
    
    
    
    
    
    private JTextArea area()
    {
    	JTextArea area = new JTextArea();
    	area.setEditable(false);
        area.setLineWrap(true);
    	area.setBackground(BACKGROUND);
    	return area;
    }
}

