package gus05.entity.gus.security.asymkeys.signedmessage.checker1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Graphic;

import javax.swing.JComponent;
import javax.swing.JTextPane;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

import java.awt.Color;
import java.security.PublicKey;
import java.security.SignatureException;




public class SignedMessageChecker1 implements Entity, Give, Provide, Graphic, DocumentListener {


    public String getName()				{return "gus.security.asymkeys.signedmessage.checker1";}
    public String getCreationDate()		{return "2008.07.01";}

    
    

    private Service verifierBuilder;
    private Filter verifier;
    
    private JTextPane0 area;

    private PublicKey publicKey;
    private String owner;
    
    private String message;
    private String line1;
    private String line2;

    private int result;
    
    

    public SignedMessageChecker1() throws Exception
    {
    	verifierBuilder = Outside.service(this,"gus.security.asymkeys.publickey.signverifier");
		
    	area = new JTextPane0();
    	area.getDocument().addDocumentListener(this);
    }



    public void give(Object obj) throws Exception
    {
    	Object[] info = (Object[]) obj;
    	if(info.length!=2) throw new Exception("wrong info number: "+info.length);
    	
    	publicKey = (PublicKey) info[0];
    	owner = (String) info[1];
    	
    	verifier = (Filter) verifierBuilder.transform(publicKey);
    	area.setText("");
    }



    public JComponent gui()
    {return area;}


    public Object provide() throws Exception
    {return publicKey;}
    
    
    
    

    
    
    
    
    
    private void updateArea()
    {
    	try
    	{
    		area.getDocument().removeDocumentListener(this);
    		int p = area.getCaretPosition();
    		
    		area.setText("");
    		rebuildArea();
    		area.initForeground(Color.BLACK);
    		
    		int length = area.getText().length();
    		if(p>length) p=length;
            area.setCaretPosition(p);
            area.getDocument().addDocumentListener(this);
    	}
    	catch(Exception e)
    	{Outside.err(this,"updateArea()",e);}
    }
    
    
    
    private void rebuildArea() throws Exception
    {
    	area.initForeground(result==3?Color.RED:Color.BLACK);
		area.appendText(message);
		if(result==3)return;
		
		area.initForeground(result==2?Color.RED:Color.BLACK);
		area.appendBoldText("\n"+line1);
		area.initForeground(result>0?Color.RED:Color.GREEN);
		area.appendBoldText("\n"+line2);
    }
    
    
    
    
    
    
    public void changedUpdate(DocumentEvent e) {}
    public void insertUpdate(DocumentEvent e) {areaEdited();}
    public void removeUpdate(DocumentEvent e) {areaEdited();}

    
    
    
    

    private void areaEdited()
    {
        SwingUtilities.invokeLater(new Runnable(){
            public void run()
            {performChange();}
        });
    }
    
    
    private void performChange()
    {
        try
        {
        	if(publicKey==null) return;
       
            result = check();
            updateArea();
        }
        catch(Exception e)
        {Outside.err(this,"performChange()",e);}
    }
    
    
    
    
    
    
    private int check() throws Exception
    {
    	String text = area.getText().replace("\r\n","\n");
        String[] lines = text.split("\n",-1);
        int number = lines.length;
        
        if(number<3)
        {
        	message = text;
        	line1 = null;
        	line2 = null;
        	return 3;
        }
        line1 = lines[number-2];
        line2 = lines[number-1];
        
        int l = text.length();
        int l1 = line1.length();
        int l2 = line2.length();
        message = text.substring(0,l-l1-l2-2);
        
        if(!line1.equals(owner)) return 2;
        if(line2.equals("")) return 1;
        
        boolean result = checkSignature(message+"\n"+line1,line2);
        if(!result) return 1;
        return 0;
    }
    
    
    private boolean checkSignature(String text, String sign) throws Exception
    {
    	try{return verifier.filter(new Object[]{text,sign});}
    	catch(SignatureException e){return false;}
    }
    
    
    
    
    
    
    
    private class JTextPane0 extends JTextPane
    {
        private StyledDocument doc;
        private SimpleAttributeSet attr;
        
        public void initBold(boolean val)
        {StyleConstants.setBold(attr, val);}
        
        public void initItalic(boolean val)
        {StyleConstants.setItalic(attr, val);}
         
        public void initUnderline(boolean val)
        {StyleConstants.setUnderline(attr, val);}
        
        public void initForeground(Color color)
        {StyleConstants.setForeground(attr, color);}
        
        public void initBackground(Color color)
        {StyleConstants.setBackground(attr, color);}
        
        public void appendText(String text) throws BadLocationException
        {doc.insertString(doc.getLength(),text,attr);}
        
        public void appendBoldText(String text) throws BadLocationException
        {
            initBold(true);
            doc.insertString(doc.getLength(),text,attr);
            initBold(false);
        }
        
        public JTextPane0()
        {
            super();
            doc = getStyledDocument();
            attr = new SimpleAttributeSet();
        }
        
        public void positionToEnd()
        {setCaretPosition(doc.getLength());}
    }
}

