package gus05.entity.gus.security.asymkeys.verifysign;


import java.security.PublicKey;
import java.security.Signature;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;



public class VerifySign implements Entity, Give {

    
    public String getName() {return "gus.security.asymkeys.verifysign";}
    public String getCreationDate() {return "2008.06.12";}
    
    
    private Service base64Decoder;
    private Signature si;
    
    
    public VerifySign() throws Exception
    {
    	base64Decoder = Outside.service(this,"gus.tobytearray.base64tobyte");
    	si = Signature.getInstance(SECURITY.SECURITY_ALGO_DSA);
    }

    
    
    public void give(Object obj) throws Exception
	{
    	Object[] infos = (Object[]) obj;
    	if(infos.length!=3)  throw new Exception("wrong info number: "+infos.length);
    	
    	PublicKey publicKey = (PublicKey) infos[0];
    	String owner = (String) infos[1];
    	String sign = (String) infos[2];
    	
    	boolean valid = verifySign(publicKey, owner, sign);
    	if(!valid) throw new Exception("sign verification failed for owner "+owner);
	}
    
    
    
    
    private boolean verifySign(PublicKey publicKey, String owner, String sign) throws Exception
    {
    	si.initVerify(publicKey);
        si.update(owner.getBytes());
        byte[] signData = decode(sign);
        return si.verify(signData);
    }
    
    
    
    private byte[] decode(String s) throws Exception
    {return (byte[]) base64Decoder.transform(s);}
} 
