
package gus05.manager.gus.endorf.layer1;

import gus05.framework.core.Entity;


public final class Source {

    private Entity entity;
    private String name;
    private String pseudo;
    private String id;
    
    private String s1;
    private String s2;
    private String s3;
    

    public Source(Entity entity, String id)
    {
        if(id==null)        throw new IllegalArgumentException("Invalid call for entity "+entity.getName()+": null id");
        if(id.equals(""))   throw new IllegalArgumentException("Invalid call for entity "+entity.getName()+": empty id");
        
        this.entity = entity;
        this.id = id;
        
        name = entity.getName();
        pseudo = name.split("\\.")[0];
        s3 = "@"+id;
        s1 = name+s3;
        s2 = pseudo+s3;
    }
    
    public String getId()           {return id;}
    public Entity getEntity()       {return entity;}
    public String getEntityName()   {return name;}
    public String getPseudo()       {return pseudo;}
    
    public String toString()        {return s1;}
    public String toString2()       {return s2;}
    public String toString3()       {return s3;}
}
