/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.manager.gus.endorf.layer2.datasupport;


import gus05.framework.features.Filter;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.tools.DefaultSupport;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;


public class SupportSet extends DefaultSupport implements Set, Retrieve, Register, Provide, Filter {

    
    private Set set;
    private String name;
    
    private String valueName = null;
	private Class valueClass = null;
    private Object lastElement;
    
    
    
    
    public SupportSet(String name, Set set)
    {
        this.set = set;
        this.name = name;
    }
    
    public SupportSet(String name)
    {
        set = new HashSet();
        this.name = name;
    }
    
    
    
    
    public String toString()
    {return name;}
    
    public Set getSet()
    {return set;}
    
    public Object getLastElement()
	{return lastElement;}
    
    

    public int size()							{return set.size();}
    public boolean isEmpty()					{return set.isEmpty();}
    public boolean contains(Object value)		{return set.contains(value);}
    public boolean containsAll(Collection c)	{return set.containsAll(c);}
    public Iterator iterator()					{return set.iterator();}
    public Object[] toArray()					{return set.toArray();}
    public Object[] toArray(Object[] array)		{return set.toArray(array);}
    public boolean equals(Object o)				{return set.equals(o);}
	
    
    
    public boolean add(Object value)
    {
        lastElement = value;
        boolean result = set.add(value);
        if(result)send(this,"add(Object)");
        return result;
    }

    
    public boolean remove(Object value)
    {
        lastElement = value;
        boolean result = set.remove(value);
        if(result)send(this,"remove(Object)");
        return result;
    }

    
    public boolean addAll(Collection c)
    {
        boolean result = set.addAll(c);    
        if(result)send(this,"addAll(Collection)");
        return result;
    }
    
    
    public boolean retainAll(Collection c)
    {
        boolean result = set.retainAll(c);    
        if(result)send(this,"retainAll(Collection)");
        return result;
    }

    
    public boolean removeAll(Collection c)
    {
        boolean result = set.removeAll(c);
        if(result)send(this,"removeAll(Collection)");
        return result;
    }

    
    public void clear()
    {
        set.clear();
        send(this,"clear()");
    }

    
    
    
    
    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("lastElement"))return lastElement;
        if(key.equals("set"))return set;

        if(key.equals("valueName"))return valueName;
        if(key.equals("valueClass"))return valueClass;
        
        if(key.equals("keys"))
            return new String[]{"lastElement","set","valueName","valueClass"};
        
        throw new Exception("unknown key "+key);
    }
    
    
    
    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("valueName"))		{valueName = (String)obj;return;}
        if(key.equals("valueClass"))	{valueClass = (Class)obj;return;}
        
        throw new Exception("unknown key "+key);
    }
    
    
    
    public boolean filter(Object obj) throws Exception 		{return set.contains(obj);}
    public Object provide() throws Exception 				{return set;}

}
