
package gus05.manager.gus.endorf.layer4.system2;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.manager.gus.endorf.layer2.datasupport.SupportMap;





public class EntityGenerator {

    
    private SimpleDateFormat sdf = new SimpleDateFormat("yyyy.MM.dd");
    
    private Map entities;
    
    public Map getEntities()
    {return entities;}
    
    public EntityGenerator()
    {entities = new SupportMap("entityUniqueMap");}
    
    
    public int number = 0;
    
    
    
    
    
    
    public Map getInfo(String name) throws Exception
    {
        if(!System2.infoMap.containsKey(name))
            throw new Exception("info not found for name "+name);
        return (Map)System2.infoMap.get(name);
    }
    
    
    
    public String multiplicity(String name) throws Exception
    {
        Map m = getInfo(name);
        return (String) m.get(System2.ENTITYINFO_MULTIPLICITY);
    }
    
    
    
    
    
    
    
    public Entity newEntity(Object source, String name) throws Exception
    {
        String sourceID = System2.sourceName(source);
        if(printCreation())
            System2.appOut.println("NEW-"+name+" (src="+sourceID+")");
        return CREATE_ENTITY(name,sourceID);
    }
    
    
    
    
    
    
    
    public Entity newEntity(Object source, String name, String key) throws Exception
    {
        String sourceID = System2.sourceName(source);
        int c = 0;
        while(entities.containsKey(key+"_"+c)) c++;
        key = key+"_"+c;
        
        if(printCreation())
            System2.appOut.println("NEW-"+name+" (key="+key+") (src="+sourceID+")");
        
        entities.put(key,CREATE_ENTITY(name,sourceID));
        return (Entity)entities.get(key);
    }
    
    
    
    
    
    
    
    public Entity uniqueEntity(Object source, String name) throws Exception
    {
        String sourceID = System2.sourceName(source);
        if(printCreation())
        {
            if(!entities.containsKey(name))
                System2.appOut.println("0-UNIQUE-"+name+" (src="+sourceID+")");
            else System2.appOut.println("UNIQUE-"+name+" (src="+sourceID+")");           
        }
        
        if(!entities.containsKey(name))
            entities.put(name,CREATE_ENTITY(name,sourceID));
        return (Entity)entities.get(name);
    }
    
    
    
    
    
    
    
    
    public Entity uniqueEntity(Object source, String name, String key) throws Exception
    {
        String sourceID = System2.sourceName(source);
        if(printCreation())
        {
            if(!entities.containsKey(key))
                System2.appOut.println("0-UNIQUE-"+name+" (key="+key+") (src="+sourceID+")");
            else System2.appOut.println("UNIQUE-"+name+" (key="+key+") (src="+sourceID+")");
        }
        
        if(!entities.containsKey(key))
            entities.put(key,CREATE_ENTITY(name,sourceID));
        return (Entity)entities.get(key);
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private Entity CREATE_ENTITY(String name, String sourceID) throws Exception
    {
        try
        {
            long time1 = System.currentTimeMillis();
            int number1 = number;
            
            // creation
            if(!System2.isEntity(name)) throw new Exception("Unknown entity: "+name);
            if(sourceID.equals(name)) throw new Exception("Entity is calling itself: "+name);
            
            Class c = System2.getEntityClass(name);
            Entity entity = (Entity)c.newInstance();
            checkEntityValidity(name,entity);
            
            long duration = System.currentTimeMillis()-time1;
            if(duration>500) System2.printDebug(this,"createEntity(String)","long creation time for entity "+name+": "+duration);
            
            int numberDiff = number-number1;
            if(numberDiff>20) System2.printDebug(this,"createEntity(String)","big creation for entity "+name+": "+numberDiff);
            
            newEntityCreated(entity);
            number++;
            return entity;
        }
        catch(Exception e)
        {
            System2.printMessage(this,"createEntity(String)","entity failed: "+name);
            throw e;
        }
    }


    
    
    
    
    
    
    private void newEntityCreated(Entity entity)
    {
        String name = entity.getName();
        String creationDate = entity.getCreationDate();
        
        // register entity creation date
        Map dateMap = (Map)System2.getInternal(System2.INTERNAL_MAP_DATEENTITY);
        if(dateMap!=null) dateMap.put(name,creationDate);
        
        // register entity used date
        Map usedMap = (Map)System2.getInternal(System2.INTERNAL_MAP_USEDDATEENTITY);
        if(usedMap!=null) usedMap.put(name,System2.now());
        
        // update the entity number
        Map numberMap = (Map)System2.getInternal(System2.INTERNAL_MAP_NUMBERENTITY);
        if(numberMap!=null)
        {
            Integer n = numberMap.containsKey(name)?(Integer)numberMap.get(name):new Integer(0);
            n = new Integer(n.intValue()+1);
            numberMap.put(name,n);
        }
    }
    
    
    
    
    
    private void checkEntityValidity(String name, Entity entity) throws Exception
    {
        String name0 = entity.getName();
        String date0 = entity.getCreationDate();
        
        if(!name0.equals(name))
            throw new Exception("entity name conflict o:"+name+" i:"+name0);
        
        String date = (String) getInfo(name).get(System2.ENTITYINFO_CREATIONDATE);
        if(!date.equals("?"))if(!date0.equals(date))
            throw new Exception("entity creation date conflict o:"+date+" i:"+date0);
        
        Date d = sdf.parse(date0);
        if(d.after(System2.appStartDate))
        System2.printWarning(this,"checkEntityValidity(String,Entity)","futurist entity creation date:"+date0);
    }
    
    
    
    
    private boolean printCreation()
    {return System2.booleanProperty_false(System2.PROPKEY_PRINTENTITYCREATIONS);}
    
}
